# Examples for EG 203 647 - Methodology for RESTful APIs specifications and testing

The ETSI Guide EG 203 647 provides guidance and methodology for RESTful API specfication and testing based on analysis of methods, languages and best practices used in the industry and in ETSI groups. More information and download of the document available [here](https://portal.etsi.org/webapp/WorkProgram/Report_WorkItem.asp?WKI_ID=56708).

The set of examples or specification and testing artefacts related to EG 203 647 are maintained in this repository and comprise the following:

* **Example OpenAPI** specification located in the *OpenAPI* folder.
* **Example requirements**, **implementation conformance statements** and **test suite structure** generated from the OpenAPI specification located in the *RQ-ICS-TSS.md* file (also available as Word document).
* **Example test purposes** and related resources in [TDL-TO](https://tdl.etsi.org) located in the *TP* folder, with automatically generated TP skeletons in the *Generated* sub-folder and manually derived TPs in the *Manual* sub-folder.
* **Example test descriptions** and related resources in [TDL](https://tdl.etsi.org) located in the *TD* folder, including *Standard* and *HTTP* libraries for TDL, as well as separate data and behaviour packages for the example. Graphical representations with TDL-GR are also included.
* **Example test cases** and related resources in [TTCN-3](http://www.ttcn-3.org) located in the *TC* folder, with automatically generated TTCN-3 skeletons in the *Generated* sub-folder and manually derived complete TTCN-3 test cases in the *Manual* sub-folder

To make the best out of the test purposes in TDL-TO and the test descriptions in TDL, it is recommended to use the TOP toolset available at [top.etsi.org](). Further information on TDL and TDL-TO is available at [tdl.etsi.org]().

## Contact

For more information on ETSI TC MTS and this project, contact `espsupport` at `etsi` dot `org`.
