# NOTE: depends on Python's json module

*** Settings ***
Resource    environment/variables.robot
Library     REST ${HTTP_SCHEME}://${IP_HOST}:${TCP_PORT}
Library     JSONLibrary
Library     JSONSchemaLibrary                               schemas/


*** Keywords ***
getResource ${id}
    Set Headers      {"Accept": "${ACCEPT_JSON}"}
    GET              ${apiRoot}/${apiName}/${apiVersion}/resource/${id}
    ${response} =    Output                                                response
    Validate Json    ResourceData.schema.json                              ${response['body']}
    ${resource} =    evaluate                                              json.loads('''${response['body']}''')    json
    [Return]         ${resource}                                           ${response}

postResource ${resource}
    Set Headers      {"Accept": "${ACCEPT_JSON}"}
    POST             ${apiRoot}/${apiName}/${apiVersion}/resource    ${resource}
    ${response} =    Output                                          response
    [Return]         ${response}
